"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var useForceRenders_1 = require("../hooks/useForceRenders");
var tools_1 = require("../utils/tools");
function createUseRender(registers) {
    function useRender(keyName, index) {
        var _a = useForceRenders_1.useForceRender(), forceRender = _a[1];
        function setRegister(key) {
            var hook = {
                keyName: key,
                index: index,
                render: forceRender
            };
            registers.set(tools_1.__keyNameIndex__(key, index), hook);
        }
        react_1.useEffect(function () {
            if (keyName !== undefined) {
                setRegister(keyName);
            }
            return function () {
                if (keyName !== undefined) {
                    registers.delete(tools_1.__keyNameIndex__(keyName, index));
                }
            };
        }, []);
        if (keyName !== undefined) {
            setRegister(keyName);
        }
        return forceRender;
    }
    return useRender;
}
exports.default = createUseRender;
